#!/usr/bin/env python

#
# DM DS Web Service
#

####################################################################

from dm.common.service.dmRestWebServiceBase import DmRestWebServiceBase
from dm.common.utility.dmModuleManager import DmModuleManager
from dm.common.utility.configurationManager import ConfigurationManager
from dm.common.processing.fileProcessingManager import FileProcessingManager
from dm.ds_web_service.service.impl.experimentManager import ExperimentManager
from dsWebServiceRouteMapper import DsWebServiceRouteMapper

####################################################################

class DsWebService(DmRestWebServiceBase):
 
    def __init__(self):
        DmRestWebServiceBase.__init__(self, DsWebServiceRouteMapper)

    def initDmModules(self):
        self.logger.debug('Initializing dm modules')

        # Add modules that will be started.
        moduleManager = DmModuleManager.getInstance()
        moduleManager.addModule(ExperimentManager.getInstance())
        moduleManager.addModule(FileProcessingManager.getInstance())
        self.logger.debug('Initialized dm modules')

    def getDefaultServerHost(self):
        return ConfigurationManager.getInstance().getServiceHost()

    def getDefaultServerPort(self):
        return ConfigurationManager.getInstance().getServicePort()

####################################################################
# Run service

if __name__ == '__main__':
    ConfigurationManager.getInstance().setServiceName('ds-web-service')
    service = DsWebService();
    service.run()
