package gov.anl.aps.dm.common.exceptions;

import gov.anl.aps.dm.common.constants.DmStatus;

/**
 * Communication error exception.
 */
public class CommunicationError extends DmException {

    /**
     * Default constructor.
     */
    public CommunicationError() {
        super();
    }

    /**
     * Constructor using error message.
     *
     * @param message error message
     */
    public CommunicationError(String message) {
        super(message);
    }

    /**
     * Constructor using throwable object.
     *
     * @param throwable throwable object
     */
    public CommunicationError(Throwable throwable) {
        super(throwable);
    }

    /**
     * Constructor using error message and throwable object.
     *
     * @param message error message
     * @param throwable throwable object
     */
    public CommunicationError(String message, Throwable throwable) {
        super(message, throwable);
    }


    @Override
    public int getErrorCode() {
        return DmStatus.DM_COMMUNICATION_ERROR;
    }     
}
