package gov.anl.aps.dm.common.exceptions;

import gov.anl.aps.dm.common.constants.DmStatus;

/**
 * DB error exception.
 */
public class DbError extends DmException {

    /**
     * Default constructor.
     */
    public DbError() {
        super();
    }

    /**
     * Constructor using error message.
     *
     * @param message error message
     */
    public DbError(String message) {
        super(message);
    }

    /**
     * Constructor using throwable object.
     *
     * @param throwable throwable object
     */
    public DbError(Throwable throwable) {
        super(throwable);
    }

    /**
     * Constructor using error message and throwable object.
     *
     * @param message error message
     * @param throwable throwable object
     */
    public DbError(String message, Throwable throwable) {
        super(message, throwable);
    }

    @Override
    public int getErrorCode() {
        return DmStatus.DM_DB_ERROR;
    }    
}
