package gov.anl.aps.dm.common.exceptions;

import gov.anl.aps.dm.common.constants.DmStatus;

/**
 * Timeout error.
 */
public class TimeoutError extends DmException {

    /**
     * Default constructor.
     */
    public TimeoutError() {
        super();
    }

    /**
     * Constructor using error message.
     *
     * @param message error message
     */
    public TimeoutError(String message) {
        super(message);
    }

    /**
     * Constructor using throwable object.
     *
     * @param throwable throwable object
     */
    public TimeoutError(Throwable throwable) {
        super(throwable);
    }

    /**
     * Constructor using error message and throwable object.
     *
     * @param message error message
     * @param throwable throwable object
     */
    public TimeoutError(String message, Throwable throwable) {
        super(message, throwable);
    }

    @Override
    public int getErrorCode() {
        return DmStatus.DM_TIMEOUT_ERROR;
    }    
}
