/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package gov.anl.aps.dm.portal.model.beans;

import gov.anl.aps.dm.portal.model.entities.ExperimentRoleType;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;
import javax.persistence.PersistenceContext;

/**
 *
 * @author sveseli
 */
@Stateless
public class ExperimentRoleTypeDbFacade extends DmEntityDbFacade<ExperimentRoleType> {

    public static final String PI_ROLE = "PI";
    public static final String USER_ROLE = "User";
    
    @PersistenceContext(unitName = "DmWebPortalPU")
    private EntityManager em;

    @Override
    protected EntityManager getEntityManager() {
        return em;
    }

    public ExperimentRoleTypeDbFacade() {
        super(ExperimentRoleType.class);
    }

    public ExperimentRoleType findByName(String name) {
        try {
            return (ExperimentRoleType) em.createNamedQuery("ExperimentRoleType.findByName")
                    .setParameter("name", name)
                    .getSingleResult();
        }
        catch (NoResultException ex) {
        }
        return null;
    }  
  
    public ExperimentRoleType findById(Integer id) {
        try {
            return (ExperimentRoleType) em.createNamedQuery("ExperimentRoleType.findById")
                    .setParameter("id", id)
                    .getSingleResult();
        }
        catch (NoResultException ex) {
        }
        return null;
    }  
    
    public ExperimentRoleType findPiRoleType() {
        try {
            return (ExperimentRoleType) em.createNamedQuery("ExperimentRoleType.findByName")
                    .setParameter("name", PI_ROLE)
                    .getSingleResult();
        }
        catch (NoResultException ex) {
        }
        return null;
    }
 
    public ExperimentRoleType findUserRoleType() {
        try {
            return (ExperimentRoleType) em.createNamedQuery("ExperimentRoleType.findByName")
                    .setParameter("name", USER_ROLE)
                    .getSingleResult();
        }
        catch (NoResultException ex) {
        }
        return null;
    }     
}
