/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package gov.anl.aps.dm.portal.model.beans;

import gov.anl.aps.dm.portal.model.entities.PolicyProperty;
import java.util.List;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;
import javax.persistence.PersistenceContext;

/**
 *
 * @author bfrosik
 */
@Stateless
public class PolicyPropertyDbFacade extends DmEntityDbFacade<PolicyProperty>
{
    @PersistenceContext(unitName = "DmWebPortalPU")
    private EntityManager em;

    @Override
    protected EntityManager getEntityManager() {
        return em;
    }
    
//    @Override
//    public void remove(PolicyProperty entity) {
//        Object o = em.merge(entity);
//        em.remove(o);
//    }


    public PolicyPropertyDbFacade() {
        super(PolicyProperty.class);
    }
    
    public PolicyProperty findByName(String name) {
        try {
            return (PolicyProperty) em.createNamedQuery("PolicyProperty.findByName")
                    .setParameter("name", name)
                    .getSingleResult();
        } catch (NoResultException ex) {
        }
        return null;
    }

    public PolicyProperty findById(int id) {
        try {
            return (PolicyProperty) em.createNamedQuery("PolicyProperty.findById")
                    .setParameter("id", id)
                    .getSingleResult();
        } catch (NoResultException ex) {
        }
        return null;
    }
    
    public List<PolicyProperty> findByPolicyTypeId(int id) {
        try {
            return (List<PolicyProperty>) em.createNamedQuery("PolicyProperty.findByPolicyTypeId")
                    .setParameter("policyTypeId", id)
                    .getResultList();
        }
        catch (NoResultException ex) {
        }
        return null;
    }
                   
}
