/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package gov.anl.aps.dm.portal.model.beans;

import gov.anl.aps.dm.portal.model.entities.SystemRoleType;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;
import javax.persistence.PersistenceContext;

/**
 *
 * @author sveseli
 */
@Stateless
public class SystemRoleTypeDbFacade extends DmEntityDbFacade<SystemRoleType> {

    public static final String ADMINISTRATOR_ROLE = "Administrator";
    public static final String MANAGER_ROLE = "Manager";
    
    @PersistenceContext(unitName = "DmWebPortalPU")
    private EntityManager em;

    @Override
    protected EntityManager getEntityManager() {
        return em;
    }

    public SystemRoleTypeDbFacade() {
        super(SystemRoleType.class);
    }

    public SystemRoleType findById(Integer id) {
        try {
            return (SystemRoleType) em.createNamedQuery("SystemRoleType.findById")
                    .setParameter("id", id)
                    .getSingleResult();
        }
        catch (NoResultException ex) {
        }
        return null;
    }   
    
    public SystemRoleType findAdministratorRoleType() {
        try {
            return (SystemRoleType) em.createNamedQuery("SystemRoleType.findByName")
                    .setParameter("name", ADMINISTRATOR_ROLE)
                    .getSingleResult();
        }
        catch (NoResultException ex) {
        }
        return null;
    } 
    
    public SystemRoleType findManagerRoleType() {
        try {
            return (SystemRoleType) em.createNamedQuery("SystemRoleType.findByName")
                    .setParameter("name", MANAGER_ROLE)
                    .getSingleResult();
        }
        catch (NoResultException ex) {
        }
        return null;
    }    
}
