#!/usr/bin/env python

from dm.common.cli.dmCli import DmCli
from dm.aps_bss.api.apsBssApi import ApsBssApi

class ListRunsCli(DmCli):
    def __init__(self):
        DmCli.__init__(self)
        self.addOption('', '--bss-login-file', dest='bssLoginFile', help='BSS login file. It may be provided via environment variable DM_BSS_LOGIN_FILE.')

    def checkArgs(self):
        pass

    def runCommand(self):
        self.parseArgs(usage="""
    dm-list-runs [--bss-login-file=BSSLOGINFILE]

Description:
    Retrieves list of available runs.
        """)
        self.checkArgs()
        api = ApsBssApi(loginFile=self.options.bssLoginFile)
        runs = api.listRuns()
        for run in runs:
            print run.getDisplayString(self.getDisplayKeys(), self.getDisplayFormat())

#######################################################################
# Run command.
if __name__ == '__main__':
    cli = ListRunsCli()
    cli.run()
