#!/usr/bin/env python

from dm.common.cli.dmRestSessionCli import DmRestSessionCli
from dm.common.utility.osUtility import OsUtility
from dm.common.utility.configurationManager import ConfigurationManager

class CatWebServiceSessionCli(DmRestSessionCli):
    """ DM CAT web service session cli class. """

    DEFAULT_SESSION_CACHE_FILE = OsUtility.getUserHomeDir() + '/.dm/.cat.session.cache'

    def __init__(self, validArgCount=0):
        DmRestSessionCli.__init__(self, validArgCount)
        ConfigurationManager.getInstance().setSessionCacheFile(CatWebServiceSessionCli.DEFAULT_SESSION_CACHE_FILE)

    def getDefaultServiceHost(self):
        return ConfigurationManager.getInstance().getCatWebServiceHost()

    def getDefaultServicePort(self):
        return ConfigurationManager.getInstance().getCatWebServicePort()

