#!/usr/bin/env python

from dm.cat_web_service.api.datasetCatApi import DatasetCatApi
from dm.common.exceptions.invalidRequest import InvalidRequest
from catWebServiceSessionCli import CatWebServiceSessionCli

class GetDatasetsCli(CatWebServiceSessionCli):
    def __init__(self):
        CatWebServiceSessionCli.__init__(self, validArgCount=self.ANY_NUMBER_OF_POSITIONAL_ARGS)

    def checkArgs(self):
        pass

    def runCommand(self):
        self.parseArgs(usage="""
    dm-get-datasets 
        [key1:value1, key2:value2, ...]

Description:
    Retrieve datasets from the metadata catalog. Only those datasets that
    match provided key/value metadata pairs will be returned. If no specific
    metadata key/values are requested, all experiment datasets will be 
    returned. 
        """)
        self.checkArgs()
        api = DatasetCatApi(self.getLoginUsername(), self.getLoginPassword(), self.getServiceHost(), self.getServicePort(), self.getServiceProtocol())
        queryDict = self.splitArgsIntoDict()
        datasetMetadataList = api.getDatasets(queryDict)
        for datasetMetadata in datasetMetadataList:
            print datasetMetadata.getDisplayString(self.getDisplayKeys(), self.getDisplayFormat())

#######################################################################
# Run command.
if __name__ == '__main__':
    cli = GetDatasetsCli()
    cli.run()

