#!/usr/bin/env python

import os
from dm.common.cli.dmRestSessionCli import DmRestSessionCli
from dm.common.utility.osUtility import OsUtility
from dm.common.utility.configurationManager import ConfigurationManager

class DaqWebServiceSessionCli(DmRestSessionCli):
    """ DM DAQ web service session cli class. """

    DEFAULT_SESSION_CACHE_FILE = OsUtility.getUserHomeDir() + '/.dm/.daq.session.cache'

    def __init__(self, validArgCount=0):
        DmRestSessionCli.__init__(self, validArgCount)
        ConfigurationManager.getInstance().setSessionCacheFile(DaqWebServiceSessionCli.DEFAULT_SESSION_CACHE_FILE)

    def getDefaultServiceHost(self):
        return ConfigurationManager.getInstance().getDaqWebServiceHost()

    def getDefaultServicePort(self):
        return ConfigurationManager.getInstance().getDaqWebServicePort()

    def getId(self):
        return self.options.id

    def getExperimentName(self):
        return self.options.experimentName


