#!/usr/bin/env python

from dm.ds_web_service.api.experimentDsApi import ExperimentDsApi
from dm.common.exceptions.invalidRequest import InvalidRequest
from dsWebServiceSessionCli import DsWebServiceSessionCli

class StartExperimentCli(DsWebServiceSessionCli):
    def __init__(self):
        DsWebServiceSessionCli.__init__(self)
        self.addOption('', '--experiment', dest='experimentName', help='Experiment name.')

    def checkArgs(self):
        if self.options.experimentName is None:
            raise InvalidRequest('Experiment name must be provided.')

    def getExperimentName(self):
        return self.options.experimentName

    def runCommand(self):
        self.parseArgs(usage="""
    dm-start-experiment --experiment=EXPERIMENTNAME

Description:
    Updates experiment start time in the DM database and prepares experiment data directory.
        """)
        self.checkArgs()
        api = ExperimentDsApi(self.getLoginUsername(), self.getLoginPassword(), self.getServiceHost(), self.getServicePort(), self.getServiceProtocol())
        experiment = api.startExperiment(self.getExperimentName())
        print experiment.getDisplayString(self.getDisplayKeys(), self.getDisplayFormat())

#######################################################################
# Run command.
if __name__ == '__main__':
    cli = StartExperimentCli()
    cli.run()

