#!/usr/bin/env python

#
# User route descriptor.
#

from dm.common.utility.configurationManager import ConfigurationManager
from workflowSessionController import WorkflowSessionController

class WorkflowRouteDescriptor:

    @classmethod
    def getRoutes(cls):
        contextRoot = ConfigurationManager.getInstance().getContextRoot()

        # Static instances shared between different routes
        workflowSessionController = WorkflowSessionController()

        # Define routes.
        routes = [

            # Get workflow
            {
                'name' : 'getWorkflowByName',
                'path' : '%s/workflowsByOwner/:(owner)/:(encodedName)' % contextRoot,
                'controller' : workflowSessionController,
                'action' : 'getWorkflowByName',
                'method' : ['GET']
            },

        ]
       
        return routes


